#ifndef IIC_MASTER_H
#define IIC_MASTER_H

#include "r_cg_macrodriver.h"
#include "type.h"
#include "iic_sender.h"
#include "iic_receiver.h"

// --- Master
typedef enum {
	eIicStatus_free,
	eIicStatus_busy,
}eIicStatus_t;

typedef enum {
	eIicRespond_standby,
	eIicRespond_busy,
	eIicRespond_end,
	eIicRespond_err,
}eIicRespond_t;

typedef enum {
	eMasterMode_standby,
	eMasterMode_send,
	eMasterMode_receive,
}eMasterMode_t;

typedef struct {
	eMasterMode_t mode;
	uint8_t addr;
    Iic_Sender_t sender;
    Iic_receiver_t receiver;
}Iic_Master_t;

void IicMaster_Init(Iic_Master_t *instance, uint8_t addr);
eIicRespond_t IicMaster_Send(
    Iic_Master_t *instance,
    uint8_t *buff,
    uint16_t size);
void IicMaster_Operate(Iic_Master_t *instance);

#endif // IIC_MASTER_H
