#ifndef IIC_RECEIVER_H
#define IIC_RECEIVER_H

#include "r_cg_macrodriver.h"
#include "type.h"
#include "timer_control.h"

#define ERR_CNT (5)

// --- Receiver
typedef enum {
	eReceiveMode_standby,
	eReceiveMode_retry,
	eReceiveMode_run,
	eReceiveMode_end,
    eReceiveMode_err,
}eReceiveMode_t;

typedef struct {
	eReceiveMode_t mode;
	uint8_t *buff;
	uint16_t buffSize;
	uint8_t errCnt;
	timer_control_t errTimer;
}Iic_receiver_t;

void IicReceiver_Init(Iic_receiver_t *receiver);

#endif // IIC_RECEIVER_H