#include "iic_sender.h"
#include "r_cg_serial.h"

static uint8_t iicSendEndFlag = 0;
static MD_STATUS iicSendErrFlag = 0;

/*
    Init
*/
void IicSender_Init(Iic_Sender_t *sender)
{
	sender->mode = eSendMode_standby;
	sender->errCnt = 0;
	// initTimer(&sender->errTimer, DTIMER_3SEC_PER1MS);
}

/*
    Set
*/
void Set_IicSendEnd(void)
{
    iicSendEndFlag = 1;
}

void Set_IicSendErr(MD_STATUS flag)
{
    iicSendErrFlag = flag;
}

/*
    Operation
*/
void IicSender_Operate(Iic_Sender_t *sender, uint8_t addr)
{
    switch (sender->mode) {
        default:
        case eSendMode_standby:
            break;
        case eSendMode_send:
            R_IIC01_Master_Send(addr, sender->buff, sender->buffSize);
            sender->mode = eSendMode_run;
            break;
        case eSendMode_run:
            if (iicSendEndFlag) {
                iicSendEndFlag = 0;
                sender->mode = eSendMode_end;
            }
            if (iicSendErrFlag) {
                iicSendErrFlag = MD_STATUSBASE;
                if (sender->errCnt < SEND_ERR_CNT) {
                    sender->mode = eSendMode_send;
                    sender->errCnt++;
                } else {
                    sender->errCnt = 0;
                    sender->mode = eSendMode_err;
                }
            }
            break;
        case eSendMode_end:
            break;
        case eSendMode_err:
            break;
    }
}