#ifndef IIC_SENDER_H
#define IIC_SENDER_H

#include "r_cg_macrodriver.h"
#include "type.h"
#include "timer_control.h"

#define SEND_ERR_CNT (5)

// --- Sender
typedef enum {
	eSendMode_standby,
	eSendMode_send,
	eSendMode_run,
	eSendMode_end,
    eSendMode_err,
}eSendMode_t;

typedef struct {
	eSendMode_t mode;
	uint8_t *buff;
	uint16_t buffSize;
	uint8_t errCnt;
	timer_control_t errTimer;
}Iic_Sender_t;

void IicSender_Init(Iic_Sender_t *sender);
void Set_IicSendEnd(void);
void Set_IicSendErr(MD_STATUS flag);
void IicSender_Operate(Iic_Sender_t *sender, uint8_t addr);

#endif // IIC_SENDER_H